SystemOrganization addCategory: #'Versionner-GLM-Browser'!

GLMBrowserTemplate subclass: #VersionnerGLMBrowser
	instanceVariableNames: 'configurationRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-GLM-Browser'!

!VersionnerGLMBrowser class methodsFor: 'as yet unclassified' stamp: 'JPSA 4/20/2012 11:12'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #VersionnerGLMBrowser)
"		order: 3; "
		parent: #Tools;
		label: 'Versionner';
		icon:  ThemeIcons versionnerIcon;
		action: [ VersionnerGLMBrowser open ]! !

!VersionnerGLMBrowser class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 2/9/2012 12:20'!
open
	VersionnerGLMBrowser new open.! !

!VersionnerGLMBrowser methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalA 3/23/2012 14:52'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Glamourous Versionner Browser'.
		
	browser 
		column: #configuration; 
		column: #version.

	browser transmit 
		to: #configuration;
		from: #outer port: #entity;
		andShow: [ :a | self configurationsOn:  a].
	
	browser transmit 
		to:#version;
		from: #configuration;
		andShow: [ :a | self versionsOn: a].
	
	^ browser.! !

!VersionnerGLMBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 2/9/2012 12:44'!
configurationRoot
	
	configurationRoot ifNil: [ configurationRoot := MBConfigurationRoot current ].
	^configurationRoot! !

!VersionnerGLMBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 2/9/2012 11:55'!
configurationRoot: aContigurationRoot
	""
	configurationRoot ifNotNil: [ configurationRoot removeDependent: self ].
	configurationRoot := aContigurationRoot
	! !

!VersionnerGLMBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 3/23/2012 14:52'!
configurations
	^ (self configurationRoot configurations).! !

!VersionnerGLMBrowser methodsFor: 'initialize-release' stamp: 'JPSA 4/20/2012 21:22'!
configurationsOn: presentation
		|list|
		list := presentation list.
		list display: [ :configurations |  configurations];
		     title:  'Projects';
			format: [ :aConfigInfo          | aConfigInfo printString];
		      icon:     [ :configuration :env |  
				(configuration isDirty)
					ifTrue:  [ VersionnerGLMIcons configurationChangedIcon] 
					ifFalse: [ VersionnerGLMIcons configurationIcon              ].].	
		
		self loadCommands: (MBConfigurationInfoCommand allSubclasses ) in: list. 		
		
		list  act:   [:a| self execute: MBAddConfigurationCommand with:self.
			             self refresh.] 
		 	icon: (VersionnerGLMIcons newConfigurationIcon) 
			entitled: 'New';
		      act: [:a| self execute: MBUpdateFromItsRepositoryCommand with:(a selectionPath first).           ]
			icon: (VersionnerGLMIcons updateIcon) 
			entitled: 'Update';
			act: [:a| self execute: MBSaveAllPackagesAndAddVersionCommand with:(a selectionPath first).] 
			icon: (VersionnerGLMIcons commitIcon) 
			entitled: 'Commit';
			act: [:a| self execute: MBLoadProjectCommand with:self.]
			icon: (VersionnerGLMIcons loadProject) 
			entitled: 'Load'.
		^ list.! !

!VersionnerGLMBrowser methodsFor: 'commands' stamp: 'JPSA 4/18/2012 16:55'!
execute: aCommandClass with: entity
	""
	(aCommandClass target: entity for: self) execute.
	
	self refresh.! !

!VersionnerGLMBrowser methodsFor: 'as yet unclassified' stamp: 'JPSA 4/18/2012 16:47'!
initialize
	self register.! !

!VersionnerGLMBrowser methodsFor: 'commands' stamp: 'JuanPabloSandovalA 6/7/2012 15:02'!
loadCommands: aCommandCollection in: aPresentation
	" adding selection actions to a list presentation"
	
	aCommandCollection do:[ :command |
			[ aPresentation selectionAct: [ :glm |
					|target|
					target := [glm selectionPath first] on: Error do:[nil].
					(command target: target for: self) execute.
					self refresh.
				] on: $i  entitled: ( command new title).
			] on: Error do:[ "nothing for now"]. ].! !

!VersionnerGLMBrowser methodsFor: 'commands' stamp: 'JuanPabloSandovalA 3/23/2012 14:54'!
open
	self register.
	self openOn: (self configurations).	! !

!VersionnerGLMBrowser methodsFor: 'commands' stamp: 'JuanPabloSandovalA 2/9/2012 19:29'!
refresh
	browser update.! !

!VersionnerGLMBrowser methodsFor: 'commands' stamp: 'JuanPabloSandovalA 2/9/2012 23:34'!
register
	"Set up dependencies"
	
	MBConfigurationRoot current announcer
		on: MBConfigurationInfoCreated send: #refresh to: self;
		on: MBConfigurationInfoChanged send: #refresh to: self;
		on: MBConfigurationInfoDeleted send: #refresh to: self;
		on: MBInfoListChanged send: #refresh to: self.
! !

!VersionnerGLMBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 3/23/2012 15:58'!
versionCommands
	|commands|
	commands := OrderedCollection new.
	commands add:MBAddDescriptionCommand.
	commands add:MBCompareToCurrentVersionCommand.
	commands add:MBCompareToStableVersionCommand.
	commands add:MBOpenForDevelopmentCommand.
	commands add:MBReleaseDevelopmentVersionCommand.
	commands add:MBSetDescriptionCommand.
	commands add:MBUpdatePackageCommand. 
	commands add:MBUpdateProjectCommand.
	^ commands.! !

!VersionnerGLMBrowser methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 4/27/2012 20:43'!
versionsOn: presentation
	|list|
	list := presentation list.
	
	list  display:[ : configuration| configuration versions ];
	      title: 'Versions';
        	format:[ : version | [version printString] on:Error do:[""]];
		icon: [:confOrPackage| (VersionnerGLMIcons versionIcon). ].
	self loadCommands: (self versionCommands) in: list. ! !
